{
  This file was automatically generated on 2012-07-26.

  If you have a bugfix for this file and want to commit it,
  please fix the bug in the generator. You can find a link
  to the generator git on tinkerforge.com
}

unit BrickletCurrent25;

{$ifdef FPC}{$mode OBJFPC}{$H+}{$endif}

interface

uses
  Device, IPConnection, LEConverter;

const
  BRICKLET_CURRENT25_FUNCTION_GET_CURRENT = 1;
  BRICKLET_CURRENT25_FUNCTION_CALIBRATE = 2;
  BRICKLET_CURRENT25_FUNCTION_IS_OVER_CURRENT = 3;
  BRICKLET_CURRENT25_FUNCTION_GET_ANALOG_VALUE = 4;
  BRICKLET_CURRENT25_FUNCTION_SET_CURRENT_CALLBACK_PERIOD = 5;
  BRICKLET_CURRENT25_FUNCTION_GET_CURRENT_CALLBACK_PERIOD = 6;
  BRICKLET_CURRENT25_FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD = 7;
  BRICKLET_CURRENT25_FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD = 8;
  BRICKLET_CURRENT25_FUNCTION_SET_CURRENT_CALLBACK_THRESHOLD = 9;
  BRICKLET_CURRENT25_FUNCTION_GET_CURRENT_CALLBACK_THRESHOLD = 10;
  BRICKLET_CURRENT25_FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD = 11;
  BRICKLET_CURRENT25_FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD = 12;
  BRICKLET_CURRENT25_FUNCTION_SET_DEBOUNCE_PERIOD = 13;
  BRICKLET_CURRENT25_FUNCTION_GET_DEBOUNCE_PERIOD = 14;
  BRICKLET_CURRENT25_CALLBACK_CURRENT = 15;
  BRICKLET_CURRENT25_CALLBACK_ANALOG_VALUE = 16;
  BRICKLET_CURRENT25_CALLBACK_CURRENT_REACHED = 17;
  BRICKLET_CURRENT25_CALLBACK_ANALOG_VALUE_REACHED = 18;
  BRICKLET_CURRENT25_CALLBACK_OVER_CURRENT = 19;

type
  TBrickletCurrent25NotifyCurrent = procedure(const current: smallint) of object;
  TBrickletCurrent25NotifyAnalogValue = procedure(const value: word) of object;
  TBrickletCurrent25NotifyCurrentReached = procedure(const current: smallint) of object;
  TBrickletCurrent25NotifyAnalogValueReached = procedure(const value: word) of object;
  TBrickletCurrent25NotifyOverCurrent = procedure of object;

  TBrickletCurrent25 = class(TDevice)
  private
    currentCallback: TBrickletCurrent25NotifyCurrent;
    analogValueCallback: TBrickletCurrent25NotifyAnalogValue;
    currentReachedCallback: TBrickletCurrent25NotifyCurrentReached;
    analogValueReachedCallback: TBrickletCurrent25NotifyAnalogValueReached;
    overCurrentCallback: TBrickletCurrent25NotifyOverCurrent;
  protected
    procedure CallbackWrapperCurrent(const packet: TByteArray); virtual;
    procedure CallbackWrapperAnalogValue(const packet: TByteArray); virtual;
    procedure CallbackWrapperCurrentReached(const packet: TByteArray); virtual;
    procedure CallbackWrapperAnalogValueReached(const packet: TByteArray); virtual;
    procedure CallbackWrapperOverCurrent(const packet: TByteArray); virtual;
  public
    constructor Create(const uid_: string);
    function GetCurrent: smallint; virtual;
    procedure Calibrate; virtual;
    function IsOverCurrent: boolean; virtual;
    function GetAnalogValue: word; virtual;
    procedure SetCurrentCallbackPeriod(const period: longword); virtual;
    function GetCurrentCallbackPeriod: longword; virtual;
    procedure SetAnalogValueCallbackPeriod(const period: longword); virtual;
    function GetAnalogValueCallbackPeriod: longword; virtual;
    procedure SetCurrentCallbackThreshold(const option: char; const min: smallint; const max: smallint); virtual;
    procedure GetCurrentCallbackThreshold(out option: char; out min: smallint; out max: smallint); virtual;
    procedure SetAnalogValueCallbackThreshold(const option: char; const min: word; const max: word); virtual;
    procedure GetAnalogValueCallbackThreshold(out option: char; out min: word; out max: word); virtual;
    procedure SetDebouncePeriod(const debounce: longword); virtual;
    function GetDebouncePeriod: longword; virtual;
    property OnCurrent: TBrickletCurrent25NotifyCurrent read currentCallback write currentCallback;
    property OnAnalogValue: TBrickletCurrent25NotifyAnalogValue read analogValueCallback write analogValueCallback;
    property OnCurrentReached: TBrickletCurrent25NotifyCurrentReached read currentReachedCallback write currentReachedCallback;
    property OnAnalogValueReached: TBrickletCurrent25NotifyAnalogValueReached read analogValueReachedCallback write analogValueReachedCallback;
    property OnOverCurrent: TBrickletCurrent25NotifyOverCurrent read overCurrentCallback write overCurrentCallback;
  end;

implementation

constructor TBrickletCurrent25.Create(const uid_: string);
begin
  inherited Create(uid_);
  expectedName := 'Current25 Bricklet';
  bindingVersion[0] := 1;
  bindingVersion[1] := 0;
  bindingVersion[2] := 0;
  callbackWrappers[BRICKLET_CURRENT25_CALLBACK_CURRENT] := {$ifdef FPC}@{$endif}CallbackWrapperCurrent;
  callbackWrappers[BRICKLET_CURRENT25_CALLBACK_ANALOG_VALUE] := {$ifdef FPC}@{$endif}CallbackWrapperAnalogValue;
  callbackWrappers[BRICKLET_CURRENT25_CALLBACK_CURRENT_REACHED] := {$ifdef FPC}@{$endif}CallbackWrapperCurrentReached;
  callbackWrappers[BRICKLET_CURRENT25_CALLBACK_ANALOG_VALUE_REACHED] := {$ifdef FPC}@{$endif}CallbackWrapperAnalogValueReached;
  callbackWrappers[BRICKLET_CURRENT25_CALLBACK_OVER_CURRENT] := {$ifdef FPC}@{$endif}CallbackWrapperOverCurrent;
end;

function TBrickletCurrent25.GetCurrent: smallint;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_CURRENT25_FUNCTION_GET_CURRENT, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_CURRENT25_FUNCTION_GET_CURRENT, response);
  result := LEConvertInt16From(4, response);
end;

procedure TBrickletCurrent25.Calibrate;
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_CURRENT25_FUNCTION_CALIBRATE, 4);
  SendRequestNoResponse(request);
end;

function TBrickletCurrent25.IsOverCurrent: boolean;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_CURRENT25_FUNCTION_IS_OVER_CURRENT, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_CURRENT25_FUNCTION_IS_OVER_CURRENT, response);
  result := LEConvertBooleanFrom(4, response);
end;

function TBrickletCurrent25.GetAnalogValue: word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_CURRENT25_FUNCTION_GET_ANALOG_VALUE, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_CURRENT25_FUNCTION_GET_ANALOG_VALUE, response);
  result := LEConvertUInt16From(4, response);
end;

procedure TBrickletCurrent25.SetCurrentCallbackPeriod(const period: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_CURRENT25_FUNCTION_SET_CURRENT_CALLBACK_PERIOD, 8);
  LEConvertUInt32To(period, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickletCurrent25.GetCurrentCallbackPeriod: longword;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_CURRENT25_FUNCTION_GET_CURRENT_CALLBACK_PERIOD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_CURRENT25_FUNCTION_GET_CURRENT_CALLBACK_PERIOD, response);
  result := LEConvertUInt32From(4, response);
end;

procedure TBrickletCurrent25.SetAnalogValueCallbackPeriod(const period: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_CURRENT25_FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD, 8);
  LEConvertUInt32To(period, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickletCurrent25.GetAnalogValueCallbackPeriod: longword;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_CURRENT25_FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_CURRENT25_FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD, response);
  result := LEConvertUInt32From(4, response);
end;

procedure TBrickletCurrent25.SetCurrentCallbackThreshold(const option: char; const min: smallint; const max: smallint);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_CURRENT25_FUNCTION_SET_CURRENT_CALLBACK_THRESHOLD, 9);
  LEConvertCharTo(option, 4, request);
  LEConvertInt16To(min, 5, request);
  LEConvertInt16To(max, 7, request);
  SendRequestNoResponse(request);
end;

procedure TBrickletCurrent25.GetCurrentCallbackThreshold(out option: char; out min: smallint; out max: smallint);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_CURRENT25_FUNCTION_GET_CURRENT_CALLBACK_THRESHOLD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_CURRENT25_FUNCTION_GET_CURRENT_CALLBACK_THRESHOLD, response);
  option := LEConvertCharFrom(4, response);
  min := LEConvertInt16From(5, response);
  max := LEConvertInt16From(7, response);
end;

procedure TBrickletCurrent25.SetAnalogValueCallbackThreshold(const option: char; const min: word; const max: word);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_CURRENT25_FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD, 9);
  LEConvertCharTo(option, 4, request);
  LEConvertUInt16To(min, 5, request);
  LEConvertUInt16To(max, 7, request);
  SendRequestNoResponse(request);
end;

procedure TBrickletCurrent25.GetAnalogValueCallbackThreshold(out option: char; out min: word; out max: word);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_CURRENT25_FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_CURRENT25_FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD, response);
  option := LEConvertCharFrom(4, response);
  min := LEConvertUInt16From(5, response);
  max := LEConvertUInt16From(7, response);
end;

procedure TBrickletCurrent25.SetDebouncePeriod(const debounce: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_CURRENT25_FUNCTION_SET_DEBOUNCE_PERIOD, 8);
  LEConvertUInt32To(debounce, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickletCurrent25.GetDebouncePeriod: longword;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_CURRENT25_FUNCTION_GET_DEBOUNCE_PERIOD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_CURRENT25_FUNCTION_GET_DEBOUNCE_PERIOD, response);
  result := LEConvertUInt32From(4, response);
end;

procedure TBrickletCurrent25.CallbackWrapperCurrent(const packet: TByteArray);
var current: smallint;
begin
  if (Assigned(currentCallback)) then begin
    current := LEConvertInt16From(4, packet);
    currentCallback(current);
  end;
end;

procedure TBrickletCurrent25.CallbackWrapperAnalogValue(const packet: TByteArray);
var value: word;
begin
  if (Assigned(analogValueCallback)) then begin
    value := LEConvertUInt16From(4, packet);
    analogValueCallback(value);
  end;
end;

procedure TBrickletCurrent25.CallbackWrapperCurrentReached(const packet: TByteArray);
var current: smallint;
begin
  if (Assigned(currentReachedCallback)) then begin
    current := LEConvertInt16From(4, packet);
    currentReachedCallback(current);
  end;
end;

procedure TBrickletCurrent25.CallbackWrapperAnalogValueReached(const packet: TByteArray);
var value: word;
begin
  if (Assigned(analogValueReachedCallback)) then begin
    value := LEConvertUInt16From(4, packet);
    analogValueReachedCallback(value);
  end;
end;

procedure TBrickletCurrent25.CallbackWrapperOverCurrent(const packet: TByteArray);
begin
  Assert(packet <> nil); { Avoid 'Parameter not used' warning }
  if (Assigned(overCurrentCallback)) then begin
    overCurrentCallback();
  end;
end;

end.
