{
  This file was automatically generated on 2012-07-26.

  If you have a bugfix for this file and want to commit it,
  please fix the bug in the generator. You can find a link
  to the generator git on tinkerforge.com
}

unit BrickletPiezoBuzzer;

{$ifdef FPC}{$mode OBJFPC}{$H+}{$endif}

interface

uses
  Device, IPConnection, LEConverter;

const
  BRICKLET_PIEZO_BUZZER_FUNCTION_BEEP = 1;
  BRICKLET_PIEZO_BUZZER_FUNCTION_MORSE_CODE = 2;
  BRICKLET_PIEZO_BUZZER_CALLBACK_BEEP_FINISHED = 3;
  BRICKLET_PIEZO_BUZZER_CALLBACK_MORSE_CODE_FINISHED = 4;

type
  TBrickletPiezoBuzzerNotifyBeepFinished = procedure of object;
  TBrickletPiezoBuzzerNotifyMorseCodeFinished = procedure of object;

  TBrickletPiezoBuzzer = class(TDevice)
  private
    beepFinishedCallback: TBrickletPiezoBuzzerNotifyBeepFinished;
    morseCodeFinishedCallback: TBrickletPiezoBuzzerNotifyMorseCodeFinished;
  protected
    procedure CallbackWrapperBeepFinished(const packet: TByteArray); virtual;
    procedure CallbackWrapperMorseCodeFinished(const packet: TByteArray); virtual;
  public
    constructor Create(const uid_: string);
    procedure Beep(const duration: longword); virtual;
    procedure MorseCode(const morse: string); virtual;
    property OnBeepFinished: TBrickletPiezoBuzzerNotifyBeepFinished read beepFinishedCallback write beepFinishedCallback;
    property OnMorseCodeFinished: TBrickletPiezoBuzzerNotifyMorseCodeFinished read morseCodeFinishedCallback write morseCodeFinishedCallback;
  end;

implementation

constructor TBrickletPiezoBuzzer.Create(const uid_: string);
begin
  inherited Create(uid_);
  expectedName := 'Piezo Buzzer Bricklet';
  bindingVersion[0] := 1;
  bindingVersion[1] := 0;
  bindingVersion[2] := 0;
  callbackWrappers[BRICKLET_PIEZO_BUZZER_CALLBACK_BEEP_FINISHED] := {$ifdef FPC}@{$endif}CallbackWrapperBeepFinished;
  callbackWrappers[BRICKLET_PIEZO_BUZZER_CALLBACK_MORSE_CODE_FINISHED] := {$ifdef FPC}@{$endif}CallbackWrapperMorseCodeFinished;
end;

procedure TBrickletPiezoBuzzer.Beep(const duration: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_PIEZO_BUZZER_FUNCTION_BEEP, 8);
  LEConvertUInt32To(duration, 4, request);
  SendRequestNoResponse(request);
end;

procedure TBrickletPiezoBuzzer.MorseCode(const morse: string);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_PIEZO_BUZZER_FUNCTION_MORSE_CODE, 64);
  LEConvertStringTo(morse, 4, 60, request);
  SendRequestNoResponse(request);
end;

procedure TBrickletPiezoBuzzer.CallbackWrapperBeepFinished(const packet: TByteArray);
begin
  Assert(packet <> nil); { Avoid 'Parameter not used' warning }
  if (Assigned(beepFinishedCallback)) then begin
    beepFinishedCallback();
  end;
end;

procedure TBrickletPiezoBuzzer.CallbackWrapperMorseCodeFinished(const packet: TByteArray);
begin
  Assert(packet <> nil); { Avoid 'Parameter not used' warning }
  if (Assigned(morseCodeFinishedCallback)) then begin
    morseCodeFinishedCallback();
  end;
end;

end.
